<script lang="ts">
    import { getContext } from 'svelte'

    import { data } from '@/stores/static'
    import type {
        Character,
        ReputationTier,
        StaticDataReputation,
        StaticDataReputationSet,
        StaticDataReputationTier,
        TippyProps,
    } from '@/types'
    import findReputationTier from '@/utils/find-reputation-tier'
    import tippy from '@/utils/tippy'

    const character: Character = getContext('character')

    export let reputation: StaticDataReputationSet

    let characterRep: number | undefined
    let repTier: ReputationTier
    let tooltip: TippyProps

    $: {
        if (character !== undefined && reputation !== undefined) {
            const repInfo =
                reputation.Both ||
                (character.faction === 0
                    ? reputation.Alliance
                    : reputation.Horde)
            const dataRep: StaticDataReputation = $data.Reputations[repInfo.Id]
            characterRep = character.reputations[repInfo.Id]

            if (characterRep !== undefined && dataRep !== undefined) {
                const tiers: StaticDataReputationTier =
                    $data.ReputationTiers[dataRep.TierId]
                repTier = findReputationTier(tiers, characterRep)
                let valueRank = repTier.MaxValue
                    ? `${repTier.Value} / ${repTier.MaxValue} ${repTier.Name}`
                    : repTier.Name

                tooltip = {
                    allowHTML: true,
                    content: `
<div class='wowthing-tooltip'>
    <h4>${dataRep.Name}</h4>
    ${valueRank}
    ${repInfo.Note !== null ? '<p><em>' + repInfo.Note + '</em></p>' : ''}
</div>`,
                }
            }
        }
    }
</script>

<style lang="scss">
    td {
        border-left: 1px solid $border-color;
        text-align: center;
    }
</style>

{#if characterRep !== undefined && tooltip !== undefined}
    <td class="reputation{repTier.Tier}" use:tippy={tooltip}
        >{repTier.Percent}%</td
    >
{:else}
    <td>&nbsp;</td>
{/if}
